﻿package 
{
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	/**
	 * ...
	 * @author Katsushi Suzuki
	 */
	public class Main extends MovieClip 
	{
		private var _photo_item:Array;
		private var _base:Sprite;
		private var _main_loader:Loader;
		
		public function Main():void 
		{
			stage.scaleMode = "noScale";
			stage.align = "TL";
			
			//読み込み
			loadXML();
		}
		
		//XMLファイルの読み込み処理
		private function loadXML():void
		{
			var req:URLRequest = new URLRequest("asset/config.xml");
			var loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, loadCompleteHandler);
			loader.addEventListener(IOErrorEvent.IO_ERROR, loadErrorHandler);
			loader.load(req);
		}
		
		//読み込みが完了した時の処理
		private function loadCompleteHandler(e:Event):void 
		{
			_photo_item = new Array();
			
			var _xml:XML = new XML( e.target.data );
			for each( var element:XML in _xml.child("photo") )
			{
				var photo:Object = new Object();
				photo.title = element.title;
				photo.thumbnail = element.thumbnail;
				photo.medium = element.medium;
				_photo_item.push(photo);
			}
			
			loadThumbnail();
		}
		
		//読み込みに失敗した時の処理
		private function loadErrorHandler(e:IOErrorEvent):void
		{
		}
		
		//画像ファイルの読み込み
		private function loadThumbnail():void
		{
			_base = new Sprite();
			_base.x = _base.y = 10;
			_base.buttonMode = true;
			addChild(_base);
			
			_main_loader = new Loader();
			_main_loader.x = 10 + 40 * 5 + 10;
			_main_loader.y = 10;
			addChild(_main_loader);
			
			for (var i:int = 0; i < _photo_item.length; i++)
			{
				var url:String = "asset/"+_photo_item[i].thumbnail;
				var req:URLRequest = new URLRequest(url);
				var loader:Loader = new Loader();
				loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadImageCompleteHandler);
				loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, loadImageErrorHandler);
				loader.load(req);
				
				//Loaderオブジェクトを表示する
				var d:Number = 80 * 0.5;
				_base.addChild(loader);
				loader.x = i % 5 * d;
				loader.y = Math.floor(i / 5) * d;
				loader.name = String(i);
				loader.addEventListener(MouseEvent.CLICK, clickImageHandler);
			}
		}
		
		//読み込みが完了した時の処理
		private function loadImageCompleteHandler(e:Event):void 
		{
			var loader:Loader = e.target.loader;
			loader.alpha = 0;
			loader.addEventListener(Event.ENTER_FRAME, function(e:Event):void {
				if (loader.alpha < 1) {
					loader.alpha += 0.1;
				}
				else {
					loader.removeEventListener(Event.ENTER_FRAME, arguments.callee );
					loader.alpha = 1;
				}
			});
			
			loader.width = Math.floor(loader.content.width / 2);
			loader.height = Math.floor(loader.content.height / 2);
		}
		
		//読み込みに失敗した時の処理
		private function loadImageErrorHandler(e:IOErrorEvent):void 
		{
			
		}
		
		//サムネイルクリック時の処理
		private function clickImageHandler(e:MouseEvent):void 
		{
			var loader:Loader = e.target as Loader;
			var url:String = "asset/"+_photo_item[uint(loader.name)].medium;
			_main_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadImageCompleteHandler);
			_main_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, loadImageErrorHandler);
			_main_loader.load(new URLRequest(url));
		}
	}
	
}