﻿package
{
	import album.model.ContentsModel;
	import album.model.PhotoModel;
	import album.view.Footer;
	import album.view.MediumView;
	import album.view.TableView;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	
	/**
	 * ...
	 * @author Katsushi Suzuki
	 */
	public class Main extends MovieClip 
	{
		private var _footer:Footer;
		private var _thumbnails:TableView;
		private var _medium:MediumView;
		
		public function Main():void 
		{
			stage.scaleMode = "noScale";
			stage.align = "TL";
			
			var model:PhotoModel = PhotoModel.instance;
			model.addEventListener(Event.COMPLETE, modelLoadHandler);
			model.addEventListener(IOErrorEvent.IO_ERROR, modelErrorHandler);
			model.load("asset/config.xml");
		}
		
		private function modelLoadHandler(e:Event):void 
		{
			run();
		}
		
		private function modelErrorHandler(e:IOErrorEvent):void 
		{
		}
		
		private function run():void
		{
			_footer = new Footer();
			_thumbnails = new TableView();
			_medium = new MediumView();
			addChild(_footer);
			addChild(_thumbnails);
			addChild(_medium);
			_thumbnails.load();
			stage.addEventListener(Event.RESIZE, resizeHandler);
			resize();
		}
		
		private function resizeHandler(e:Event):void 
		{
			resize();
		}
		
		private function resize():void
		{
			var w:Number = stage.stageWidth;
			var h:Number = stage.stageHeight;
			_footer.onResize(w, h);
			_thumbnails.onResize(w, h);
			_medium.onResize(w, h);
		}
	}
	
}