package album.model 
{
	import album.vo.PhotoVo;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IOErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	/**
	 * ...
	 * @author Katsushi Suzuki
	 */
	public class PhotoModel extends EventDispatcher
	{
		public var items:Array;
		private static var _instance:PhotoModel;

		public function PhotoModel(enforcer:SingletonEnforcer):void{
			
		}
		
		//XMLファイルの読み込み処理
		public function load( url:String ):void
		{
			var req:URLRequest = new URLRequest(url);
			var loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, loadCompleteHandler);
			loader.addEventListener(IOErrorEvent.IO_ERROR, loadErrorHandler);
			loader.load(req);
		}
		
		//読み込みが完了した時の処理
		private function loadCompleteHandler(e:Event):void 
		{
			items = new Array();
			var i:uint = 0;
			var _xml:XML = new XML( e.target.data );
			for each( var element:XML in _xml.child("photo") )
			{
				items.push( new PhotoVo( i++, element.title, element.thumbnail, element.medium) );
			}
			
			//読み込み完了を通知
			dispatchEvent(new Event(Event.COMPLETE));
		}
		
		//読み込みに失敗した時の処理
		private function loadErrorHandler(e:IOErrorEvent):void
		{
			dispatchEvent(new Event(IOErrorEvent.IO_ERROR));
		}

		public static function get instance():PhotoModel
		{
			if(PhotoModel._instance == null )PhotoModel._instance = new PhotoModel(new SingletonEnforcer());
			return PhotoModel._instance;
		}
		
	}
	
}
class SingletonEnforcer{}