package album.view 
{
	import album.model.ContentsModel;
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	/**
	 * ...
	 * @author Katsushi Suzuki
	 */
	public class Footer extends Sprite
	{
		private var img:Class;
		
		[Embed(source="/../asset/title.png")]
		public var Image01:Class;
		
		[Embed(source="/../asset/copyright.png")]
		public var Image02:Class;
		
		[Embed(source="/../asset/prev_btn.png")]
		public var Image03:Class;
		
		[Embed(source="/../asset/next_btn.png")]
		public var Image04:Class;
		
		private var _bitmap1:Bitmap;
		private var _bitmap2:Bitmap;
		private var _bitmap3:Bitmap;
		private var _bitmap4:Bitmap;
		private var _prev:Sprite;
		private var _next:Sprite;
		
		public function Footer() 
		{			
			try{
				_bitmap1 = new Image01() as Bitmap;
				_bitmap2 = new Image02() as Bitmap;
				_bitmap3 = new Image03() as Bitmap;
				_bitmap4 = new Image04() as Bitmap;
			}
			catch (e:Error){
				_bitmap1 = new Bitmap(new title_png(0,0));
				_bitmap2 = new Bitmap(new copyright_png(0,0));
				_bitmap3 = new Bitmap(new prev_btn_png(0,0));
				_bitmap4 = new Bitmap(new next_btn_png(0,0));
			}
			addChild(_bitmap1);
			addChild(_bitmap2);
			addChild(_bitmap3);
			addChild(_bitmap4);
			_bitmap1.x = 10;
			_bitmap3.visible = false;
			_bitmap4.visible = false;
			
			_prev = addChild(new Sprite()) as Sprite;
			_next = addChild(new Sprite()) as Sprite;
			_prev.buttonMode = true;
			_next.buttonMode = true;
			
			_prev.addEventListener(MouseEvent.CLICK, clickHandler);
			_next.addEventListener(MouseEvent.CLICK, clickHandler);
			_prev.addChild(_bitmap3);
			_next.addChild(_bitmap4);
			
			ContentsModel.instance.addEventListener("update", updateHandler);
		}
		
		private function clickHandler(e:MouseEvent):void 
		{
			if (e.target == _prev) {
				ContentsModel.instance.prev();
			}
			else{
				ContentsModel.instance.next();
			}
			ContentsModel.instance.dispatchEvent(new Event("update"));
		}
		
		private function updateHandler(e:Event):void
		{
			if (ContentsModel.instance.photoVo == null) {
				_bitmap3.visible = false;
				_bitmap4.visible = false;
			}
			else {
				_bitmap3.visible = true;
				_bitmap4.visible = true;
			}
		}
		
		public function onResize(w:Number, h:Number):void
		{
			this.y = h - 10;
			_bitmap1.y = -_bitmap1.height;
			_bitmap2.y = -_bitmap2.height + 1;
			_bitmap2.x = w - _bitmap2.width - 10;
			
			_bitmap3.x = w/2-62
			_bitmap3.y = -8;
			
			_bitmap4.x = w / 2 + 28;
			_bitmap4.y = -8;
		}
		
	}

}