package album.view 
{
	import album.model.ContentsModel;
	import album.vo.PhotoVo;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	/**
	 * ...
	 * @author Katsushi Suzuki
	 */
	public class MediumView extends Sprite
	{		
		private var _loader:Loader;
		public function MediumView() 
		{
			visible = false;
			buttonMode = true;
			ContentsModel.instance.addEventListener("update", updateHandler);
			addEventListener(MouseEvent.CLICK, clickHandler);
			
			_loader = new Loader();
			_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadImageCompleteHandler);
			_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, loadImageErrorHandler);
			addChild(_loader);
		}
		
		private function updateHandler(e:Event):void
		{
			if (ContentsModel.instance.photoVo == null) visible = false;
			else {
				visible = true;
				load();
			}
		}
		
		private function load():void
		{
			var vo:PhotoVo = ContentsModel.instance.photoVo;
			var url:String = "asset/"+vo.medium;
			var req:URLRequest = new URLRequest(url);
			_loader.load(req);
		}
		
		private function clickHandler(e:MouseEvent):void 
		{
			ContentsModel.instance.photoVo = null;
			ContentsModel.instance.dispatchEvent(new Event("update"));
		}
		
		
		private function loadImageCompleteHandler(e:Event):void 
		{
			var loader:Loader = e.target.loader;
			loader.alpha = 0;
			loader.addEventListener(Event.ENTER_FRAME, function(e:Event):void {
				if (loader.alpha < 1) {
					loader.alpha += 0.1;
				}
				else {
					loader.removeEventListener(Event.ENTER_FRAME, arguments.callee );
					loader.alpha = 1;
				}
			});
			
			loader.x = -(loader.width / 2)>>0;
			loader.y = -(loader.height / 2)>>0;
		}
		
		private function loadImageErrorHandler(e:IOErrorEvent):void 
		{
		}
		
		public function onResize(w:Number, h:Number):void
		{
			this.x = (w / 2)>>0;
			this.y = (h / 2)>>0;
		}
		
	}

}