package album.view 
{
	import album.model.ContentsModel;
	import album.vo.PhotoVo;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	/**
	 * ...
	 * @author Katsushi Suzuki
	 */
	public class Thumbnail extends Sprite
	{
		public var vo:PhotoVo;
		
		public function Thumbnail() 
		{
			buttonMode = true;
		}
		
		public function load(vo:PhotoVo):void
		{
			this.vo = vo;
			var url:String = "asset/"+vo.thumbnail;
			var req:URLRequest = new URLRequest(url);
			var loader:Loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadImageCompleteHandler);
			loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, loadImageErrorHandler);
			loader.load(req);
			addChild(loader);
			addEventListener(MouseEvent.CLICK, clickHandler);
			addEventListener(MouseEvent.MOUSE_OVER, overHandler);
			addEventListener(MouseEvent.MOUSE_OUT, outHandler);
		}
		
		private function overHandler(e:MouseEvent):void 
		{
			alpha = 0.6;
		}
		
		private function outHandler(e:MouseEvent):void 
		{
			alpha = 1;
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			ContentsModel.instance.photoVo = this.vo;
			ContentsModel.instance.dispatchEvent(new Event("update"));
		}
		
		
		private function loadImageCompleteHandler(e:Event):void 
		{
			var loader:Loader = e.target.loader;
			loader.alpha = 0;
			loader.addEventListener(Event.ENTER_FRAME, function(e:Event):void {
				if (loader.alpha < 1) {
					loader.alpha += 0.1;
				}
				else {
					loader.removeEventListener(Event.ENTER_FRAME, arguments.callee );
					loader.alpha = 1;
				}
			});
			
		}
		
		private function loadImageErrorHandler(e:IOErrorEvent):void 
		{
		}
		
	}

}